//these are the only two lines you need to edit!
local flashColor = skincolors[SKINCOLOR_CHARMELEON] //change this to your desired skincolor!
local flashDelay = 5  //change this to how many tics it takes to animate

local function LookForPlayer(mo)  //Old P_LookForEnemis
	local lastplayer
	local dist
	local lastdist = 0

	for player in players.iterate()
		if player == mo.player // 'Ignore us' check
			continue
		end
		
		if (player.playerstate != PST_LIVE) // I'm Dead.
			continue
		end

		// Can't get it if you can't see it!
		if not P_CheckSight(mo,player.mo)
			continue
		end

		dist = P_AproxDistance(P_AproxDistance(mo.x - player.mo.x, mo.y - player.mo.y), mo.z - player.mo.z)
		if (lastmo and (dist > lastdist)) // Last one is closer to you?
			continue
		end
		
		local long = R_PointToDist2(mo.x, mo.y, player.mo.x, player.mo.y)
		local longz = R_PointToDist(mo.z, player.mo.z)
		if long > 1000*FRACUNIT
		and (longz > 300*FRACUNIT or longz < -300*FRACUNIT)
			continue
		end	

		// Found a target
		lastplayer = player.mo
		lastdist = dist
	end
	return lastplayer
end

local function RampChange()
	for player in players.iterate() do
		if player.skincolor == SKINCOLOR_CHARMELEON
			local target = LookForPlayer(player.mo)
			if target
				if player.mo.color != target.color
					local ghost = P_SpawnGhostMobj(player.mo)
					ghost.color = player.mo.color
					ghost.colorized = true
					ghost.cham = true
					player.mo.color = target.color
				end
			end	
			if not (leveltime % flashDelay) then
				if target
					player.mo.color = target.color
				end	
			end	
		end	
	end	
end

addHook("ThinkFrame", RampChange)

addHook("MobjThinker", function(mo)
	if mo.valid
		if mo.cham == true
			mo.scale = $1 + FRACUNIT/15
		end
	end
end, MT_GHOST)